QWidgetStack(3qt)

NAME
QWidgetStack - Stack of widgets of which only the top widget is user-visible

SYNOPSIS
#include <qwidgetstack.h>

Inherits QFrame.

  Public Members
QWidgetStack ( QWidget * parent = 0, const char * name = 0 )
QWidgetStack ( QWidget * parent, const char * name, WFlags f )
~QWidgetStack ()
int addWidget ( QWidget * w, int id = -1 )
void removeWidget ( QWidget * w )
QWidget * widget ( int id ) const
int id ( QWidget * widget ) const
QWidget * visibleWidget () const

  Public Slots
void raiseWidget ( int id )
void raiseWidget ( QWidget * w )

  Signals
void aboutToShow ( int )
void aboutToShow ( QWidget * )

  Protected Members
virtual void setChildGeometries ()

DESCRIPTION
The QWidgetStack class provides a stack of widgets of which only the top widget is user-visible.

The application programmer can move any widget to the top of the stack at any time using raiseWidget(), and add or remove widgets using addWidget() and removeWidget(). It is not sufficient to pass the widget stack as parent to a widget which should be inserted into the widgetstack.

visibleWidget() is the get equivalent of raiseWidget(); it returns a pointer to the widget that is currently at the top of the stack.

QWidgetStack also provides the ability to manipulate widgets through application-specified integer IDs. You can also translate from widget pointers to IDs using id() and from IDs to widget pointers using widget(). These numeric IDs are unique (per QWidgetStack, not globally), but QWidgetStack does not attach any additional meaning to them.

The default widget stack is frameless, but you can use the usual QFrame functions (such as setFrameStyle()) to add a frame.

QWidgetStack provides a signal, aboutToShow(), which is emitted just before a managed widget is shown.

See also QTabDialog, QTabBar, QFrame, and Organizers.

MEMBER FUNCTION DOCUMENTATION

QWidgetStack::QWidgetStack ( QWidget * parent = 0, const char * name = 0 )
Constructs an empty widget stack.

The parent and name arguments are passed to the QFrame constructor.

QWidgetStack::QWidgetStack ( QWidget * parent, const char * name, WFlags f )
Constructs an empty widget stack.

The parent, name and f arguments are passed to the QFrame constructor.

QWidgetStack::~QWidgetStack ()
Destroys the object and frees any allocated resources.

void QWidgetStack::aboutToShow ( int ) [signal]
This signal is emitted just before a managed widget is shown if that managed widget has an ID != -1. The argument is the numeric ID of the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget it returns is the one that is currently visible, not the one that is about to be shown.

void QWidgetStack::aboutToShow ( QWidget * ) [signal]
This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

This signal is emitted just before a managed widget is shown. The argument is a pointer to the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget returned is the one that is currently visible, not the one that is about to be shown.

int QWidgetStack::addWidget ( QWidget * w, int id = -1 )
Adds widget w to this stack of widgets, with ID id.

If you pass an id >= 0 this ID is used. If you pass an id of -1 (the default), the widgets will be numbered automatically. If you pass -2 a unique negative integer will be generated. No widget has an ID of -1. Returns the ID or -1 on failure (e.g. \w is 0).

If you pass an id that is already used, then a unique negative integer will be generated to prevent two widgets having the same id.

If w is not a child of this QWidgetStack moves it using reparent().

Example: xform/xform.cpp.

int QWidgetStack::id ( QWidget * widget ) const
Returns the ID of the widget. Returns -1 if widget is 0 or is not being managed by this widget stack.

See also widget() and addWidget().

void QWidgetStack::raiseWidget ( int id ) [slot]
Raises the widget with ID id to the top of the widget stack.

See also visibleWidget().

Example: xform/xform.cpp.

void QWidgetStack::raiseWidget ( QWidget * w ) [slot]
This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

Raises widget w to the top of the widget stack.

void QWidgetStack::removeWidget ( QWidget * w )
Removes widget w from this stack of widgets. Does not delete w. If w is the currently visible widget, no other widget is substituted.

See also visibleWidget() and raiseWidget().

void QWidgetStack::setChildGeometries () [virtual protected]
Fixes up the children's geometries.

QWidget * QWidgetStack::visibleWidget () const
Returns the currently visible widget (the one at the top of the stack), or 0 if nothing is currently being shown.

See also aboutToShow(), id(), and raiseWidget().

QWidget * QWidgetStack::widget ( int id ) const
Returns the widget with ID id. Returns 0 if this widget stack does not manage a widget with ID id.

See also id() and addWidget().

SEE ALSO
http://doc.trolltech.com/qwidgetstack.html http://www.trolltech.com/faq/tech.html

COPYRIGHT
Copyright 1992-2001 Trolltech AS, http://www.trolltech.com. See the license file included in the distribution for a complete license statement.

AUTHOR
Generated automatically from the source code.

BUGS
If you find a bug in Qt, please report it as described in http://doc.trolltech.com/bughowto.html. Good bug reports help us to help you. Thank you.

The definitive Qt documentation is provided in HTML format; it is located at $QTDIR/doc/html and can be read using Qt Assistant or with a web browser. This man page is provided as a convenience for those users who prefer man pages, although this format is not officially supported by Trolltech.

If you find errors in this manual page, please report them to qt-bugs@trolltech.com. Please include the name of the manual page (qwidgetstack.3qt) and the Qt version (3.2.1).